heap.heapinterface

## Interface Heap

- All Known Subinterfaces:
    JustifiableHeap
  All Known Implementing Classes:
    RealHeap, RealJustifiableHeap

      public interface Heap

  Obecná specifikace haldy.

  Popis: interface obecné haldy

  Užití: Implementujte třídou.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `SearchableElement` | `get()` Vyjme nejmenší prvek z haldy.
    `int` | `getCount()` Zjistí počet prvků v haldě.
    `int` | `getOperationCounter()` Provozní měření.
    `boolean` | `isEmpty()` Zjistí, zda je halda prázdná.
    `boolean` | `isFull()` Zjistí, zda je halda plná.
    `void` | `put(SearchableElement elem)` Přidá nový prvek do haldy.
    `void` | `search(HeapCallBack callBack)` Systematicky prochází haldu vrchol po vrcholu.

- - ### Method Detail

    - #### put

          void put(SearchableElement elem)

      Přidá nový prvek do haldy.
      Parameters:
        `elem` - prvek, který se má přidat

    - #### get

          SearchableElement get()

      Vyjme nejmenší prvek z haldy.
      Returns:
        nejmenší prvek

    - #### isEmpty

          boolean isEmpty()

      Zjistí, zda je halda prázdná.
      Returns:
        true když je prázdná, jinak false

    - #### isFull

          boolean isFull()

      Zjistí, zda je halda plná.
      Returns:
        true když je plná, jinak false

    - #### getCount

          int getCount()

      Zjistí počet prvků v haldě.
      Returns:
        počet prvků v haldě

    - #### search

          void search(HeapCallBack callBack)

      Systematicky prochází haldu vrchol po vrcholu. V každém vrcholu je uložen prvek, který se zpracuje metodou callback.ProcessCurrentElement (). Objekt callback je parametrem metody search.
      Parameters:
        `callBack` - objekt, který zpracuje každý prvek haldy

    - #### getOperationCounter

          int getOperationCounter()

      Provozní měření.
      Returns:
        počet významných operací